<template>
  <div>
    <crumbs
      :title="
        type === 'success'
          ? '危急值提醒-辅助检查规则测试-成功条数'
          : '危急值提醒-辅助检查规则测试-失败条数'
      "
      class="topBack"
      :param="$route.params"
      linkTo="KnowledgeMapRuleTest"
    >
      <el-form :inline="true" class="demo-form-inline">
        <el-form-item style="marginbottom: 0px">
          <el-button size="mini" @click="exportData">导出</el-button>
        </el-form-item>
      </el-form>
    </crumbs>
    <div style="margin: 60px 20px 0">
      <el-table :data="list" border>
        <el-table-column
          :resizable="false"
          type="index"
          :index="indexMethod"
          label="编号"
          width="80"
        ></el-table-column>
        <el-table-column
          :resizable="false"
          prop="gmtModified"
          label="测试时间"
        ></el-table-column>
        <el-table-column
          :resizable="false"
          prop="criticalItemName"
          label="辅检名称（标准术语）"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          :resizable="false"
          prop="criticalItemHisName"
          label="辅检名称（医院术语）"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          :resizable="false"
          prop="inputValue"
          label="辅检结果描述"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          :resizable="false"
          prop="output"
          label="实际结果"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          :resizable="false"
          prop="expectedOutput"
          label="预期结果"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column label="测试结果">
          <template slot-scope="scope">
            {{ scope.row.success === 1 ? '成功' : '失败' }}
          </template>
        </el-table-column>
        <el-table-column
          v-if="type !== 'success'"
          :resizable="false"
          prop="message"
          label="失败原因"
          show-overflow-tooltip
        ></el-table-column>
      </el-table>
      <div class="pagination pagepage">
        <el-pagination
          :current-page.sync="currentPage"
          @current-change="currentChange"
          background
          :page-size="pageSize"
          :page-sizes="pageSizeArr"
          @size-change="handleSizeChange"
          :layout="pageLayout"
          :total="total"
        ></el-pagination>
      </div>
    </div>
  </div>
</template>

<script>
import api from '@api/cdss.js';
import config from '@api/config.js';
import utils from '@api/utils.js';
export default {
  data() {
    return {
      list: [],
      currentPage: 1,
      pageSize: config.pageSize,
      pageSizeArr: config.pageSizeArr,
      pageLayout: config.pageLayout,
      total: 0,
      type: '',
    };
  },
  created() {
    const params = this.handleInitData();
    this.getDataList();
    // 非首页 编辑页返回 设置 this.currentPage
    if (Object.keys(this.$route.params).length !== 0) {
      this.currentPage = this.$route.params.currentPage;
    }
  },
  beforeRouteEnter(to, from, next) {
    next((vm) => {
      //const pm = to.param;
      Object.assign(vm, to.params);
      vm.inCurrentPage = to.params.currentPage;
    });
  },
  methods: {
    handleInitData() {
      const { data, type } = this.$route.params;
      this.type = type;
      let criticalType; // 开单合理性规则类型  1  通用  2 输血
      if (data && data.caseName === '危机值提醒_实验室检查规则') {
        criticalType = 1;
      } else if (data && data.caseName === '危机值提醒_辅助检查规则') {
        criticalType = 2;
      }
      return {
        current: this.inCurrentPage || this.currentPage,
        size: this.pageSize,
        criticalType,
        resultId: data && data.resultId,
        success: type === 'success' ? 1 : 0,
      };
    },
    indexMethod(index) {
      return (this.currentPage - 1) * this.pageSize + index + 1;
    },
    currentChange(next) {
      this.currentPage = next;
      this.getDataList(true);
    },
    handleSizeChange(val) {
      this.pageSize = val;
      this.currentPage = utils.getCurrentPage(
        this.currentPage,
        this.total,
        this.pageSize
      );
      this.getDataList();
    },

    getDataList() {
      const params = this.handleInitData();
      this.searched = true;
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)',
      });
      api.getResultCriticalPage(params).then((res) => {
        loading.close();
        if (res.data.code === '0') {
          this.list = res.data.data && res.data.data.records;
        }
        this.total = res.data.data && res.data.data.total;
        if (this.inCurrentPage !== undefined) {
          this.currentPage = this.inCurrentPage;
          this.inCurrentPage = undefined;
        }
      });
    },
    // 导出
    exportData() {
      const { data, hospitalId, hospitalName, type } = this.$route.params;
      let params = {
        success: type === 'success' ? 1 : 0,
        resultId: data.resultId,
        criticalType: 2, //1：检验，2：检查
      };
      this.$alert('确定要导出规则测试结果吗？', '', {
        confirmButtonText: '确定',
        title: '提示',
        type: 'warning',
      })
        .then(() => {
          api.criticalExportExcel(params).then((res) => {
            if (res.status === 200) {
              this.$message({ message: '导出成功', type: 'success' });
              utils.downloadExportedData(
                res.data,
                `${hospitalName}-辅助检查危急值提醒规则测试结果.xls`
              );
            }
          });
        })
        .catch(() => {});
    },
  },
};
</script>

<style lang="less" scored>
@import '../../../less/admin.less';
</style>